> For the complete documentation index, see [llms.txt](https://docs.fractalworks.io/joule/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fractalworks.io/joule/use-case-examples/telco/imsi-opt-out.md).

# IMSI Opt-Out

***

Within sensitive processing environments users may opt-out of personal data processing, for example real-time marketing or cross site tracking. To address this requirement event filtering is applied at the first stage of processing, known as opt-out.

Joule has an OOTB filtering processor which applies a custom Javascript expression to perform the filtering. This example simply filters a single IMSI from the processing pipeline.

## Use case configuration

*File: app-filtering.env*

```bash
SOURCEFILE=conf/sources/mobileSimulatedStream.yaml
ENGINEFILE=conf/usecases/filtering/mobileEventFiltering.yaml
PUBLISHFILE=conf/publishers/filteredMobileEventsFile.yaml
```

## Pipeline configuration <a href="#processor-configuration" id="processor-configuration"></a>

This pipeline will remove events that do not have values for the IMSI field as this can often occur in production system. The pipeline will also filter out and events with the IMSI set to `310120265624299`.&#x20;

```yaml
processing unit:
  pipeline:
    - filter:
        expression: "(imsi !== null ) ? true : false;"
    - filter:
        expression: "(imsi !== '310120265624299' ) ? true : false;"
```

## Note

Stay tuned as I will be putting together a static and dynamic solution that addresses a flexible approach to customer opt-out.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fractalworks.io/joule/use-case-examples/telco/imsi-opt-out.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
